/**
 * \file
 *
 * \brief AVRTWIPʕɑ΂鎎ײނ𐶐邽߂̉p
 *
 * 쌠 (C) 2014-2015 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *    Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *    ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *    (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *    ł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
/*
 * xFAQ: <a href="http://www.atmel.com/design-support/">Atmelx</a>q˂ĂB
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include "TWI_Master.h"

static unsigned char TWI_buf[ TWI_BUFFER_SIZE ];	// TWIMɏՕ
static unsigned char TWI_msgSize;					// M޲Đ
static unsigned char TWI_state = TWI_NO_STATE;		// TWI޲(TWI_NO_STATE)

union TWI_statusReg TWI_statusReg = {0};			// ׸(TWI_statusRegTWI_Master.hŒ`Ă܂B)

/****************************************************************************
TWI呕ȕҋ@Ԃɐݒ肷ɂ͂̊֐ĂłBTWI
Ɏ剞pŊ荞݂邱ƂYȂłB
****************************************************************************/
void TWI_Master_Initialize(void)
{
	TWBR = TWI_TWBR;							// ޯđxݒ(ͯ ̧قŒ`)
	TWDR = 0xFF;								// ްl(SDAJɂ܂B)
	TWCR = (1<<TWEN)|							// TWI
		   (0<<TWIE)|(0<<TWINT)|				// TWI荞݋֎~
		   (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|		// TWI޽J(NACK)
		   (0<<TWWC);							//
}

/****************************************************************************
TWI荞ݏٰ݂]Z𒲂ׂɂ͂̊֐ĂłB
****************************************************************************/
unsigned char TWI_Transceiver_Busy( void )
{
	return ( TWCR & (1<<TWIE) );				// TWI荞݂ȂAMZłB
}

/****************************************************************************
Ȍԏ擾ɂ͂̊֐ĂłB֐TWI荞ݏ
ٰ݂O܂ŎsT܂(ҋ@)Bُ킪ꍇA֐
TWIԕԂ܂B
****************************************************************************/
unsigned char TWI_Get_State_Info( void )
{
	while ( TWI_Transceiver_Busy() );			// TWI]܂őҋ@
	return ( TWI_state );						// TWIԕƋɕA
}

/****************************************************************************
\ߗpӂꂽүނ𑗂ɂ͂̊֐ĂłB擪޲Ă͏]uڽ
Ɠǂ/(R/W)ޯĂ܂܂Ȃ΂Ȃ܂B޲Ăׂ͑ްA܂
͏]uǂނׂްɑ΂̈ʒu܂݂܂B܂Aڽ ޲Ă܂߂ĉ
޲Ă󂳂ׂ܂݂܂B֐TWI荞ݏٰ݂OA
Ď̑Ė߂܂ŎsT܂(ҋ@)B
****************************************************************************/
void TWI_Start_Transceiver_With_Data( unsigned char *msg, unsigned char msgSize )
{
	unsigned char temp;

	while ( TWI_Transceiver_Busy() );				// TWI܂őҋ@
	TWI_msgSize = msgSize;							// M޲Đ(ۑ)
	TWI_buf[0]  = msg[0];							// ]uڽ+R/WޯĂg̊ɏՕ֕
	if (!( msg[0] & (TRUE<<TWI_READ_BIT) ))			// 呕uݓŁA
	{
		for ( temp = 1; temp < msgSize; temp++ )	// Mްg̊ɏՕ֕
			TWI_buf[ temp ] = msg[ temp ];
	}
	TWI_statusReg.all = 0;							// S׸ޏ((0))
	TWI_state         = TWI_NO_STATE ;				// TWIԂȂԂɐݒ
	TWCR = (1<<TWEN)|								// TWI
		   (1<<TWIE)|(1<<TWINT)|					// TWI荞݋,TWI荞ݗv׸މ(0)
		   (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|			// JnoJn
		   (0<<TWWC);								//
}

/****************************************************************************
ŏIүނđɂ͂̊֐ĂłBײނ͒OɑMɏՕ
ɒuꂽްĎgp܂B֐TWI荞ݏٰ݂OA
Ď̑Ė߂܂ŎsT܂(ҋ@)B
****************************************************************************/
void TWI_Start_Transceiver( void )
{
	while ( TWI_Transceiver_Busy() );				// TWI܂őҋ@
	TWI_statusReg.all = 0;							// S׸ޏ((0))
	TWI_state         = TWI_NO_STATE ;				// TWIԂȂԂɐݒ
	TWCR = (1<<TWEN)|								// TWI
		   (1<<TWIE)|(1<<TWINT)|					// TWI荞݋,TWI荞ݗv׸މ(0)
		   (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|			// JnoJn
		   (0<<TWWC);								//
}

/****************************************************************************
TWIMޯ̧vްǂݏoɂ͂̊֐ĂłB
ƁAްv]u֑邽߁ATWI_Start_Transceiver_With_Data֐
łBĂ炪ް擾邽߂ɂ̊֐𑖂点
Bްuꏊւ߲(ڽ̈܂߂)v޲Đ֐Ă
oɊ܂߂ĂB֐ްǂݏoĖ߂OɁATWI荞ݏٰ݂
O܂ŎsT܂(ҋ@)Bُ킪ꍇA֐TWI
ԕԂ܂B
****************************************************************************/
unsigned char TWI_Get_Data_From_Transceiver( unsigned char *msg, unsigned char msgSize )
{
	unsigned char i;

	while ( TWI_Transceiver_Busy() );				// TWI܂őҋ@
	if( TWI_statusReg.lastTransOK )					// ŏI]ŁA
	{
		for ( i=0; i<msgSize; i++ )					// MɏՕ牞pɏՕ֓e
		{
			msg[ i ] = TWI_buf[ i ];
		}
	}
	return( TWI_statusReg.lastTransOK );			// L/׸ނƋɕA
}

// * 荞ݏ *
/****************************************************************************
̊֐͊荞ݏٰ(ISR)ŁATWIۂNɕKNTWI荞
ݎɎIɌĂ΂܂B̊֐͎剞p璼ڌĂ΂ׂł͂܂B
****************************************************************************/
ISR(TWI_vect)
{
	static unsigned char TWI_bufPtr;

	switch (TWSR)
	{
	case TWI_START:						// Jno
	case TWI_REP_START:					// đJno
		TWI_bufPtr = 0;								// MɏՕʒuwq
	case TWI_MTX_ADR_ACK:				// SLA+WM,ACKM
	case TWI_MTX_DATA_ACK:				// ް ޲đM,ACKM
		if (TWI_bufPtr < TWI_msgSize)				// ɏՕc޲ėLŁA
		{
			TWDR = TWI_buf[TWI_bufPtr++];				// Ή޲ĂTWDRɕ,ʒuwqis
			TWCR = (1<<TWEN)|							// TWI
				   (1<<TWIE)|(1<<TWINT)|				// TWI荞݋,TWI荞ݗv׸މ(0)
				   (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|		// NACKw
				   (0<<TWWC);							//
		}
		else										// ɍŏI޲čς݂ŁA
		{
			TWI_statusReg.lastTransOK = TRUE;			// ]׸ސݒ(1)
			TWCR = (1<<TWEN)|							// TWI
				   (0<<TWIE)|(1<<TWINT)|				// TWI荞݋֎~,TWI荞ݗv׸މ(0)
				   (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)|		// ~oJn
				   (0<<TWWC);							//
		}
		 break;
	case TWI_MRX_DATA_ACK:				// ް ޲ĎM,ACKԓ
		TWI_buf[TWI_bufPtr++] = TWDR;				// MްlTWIMɏՕɊi[
	case TWI_MRX_ADR_ACK:				// SLA+RM,ACKM
		if (TWI_bufPtr < (TWI_msgSize-1) )			// ŏI޲ĈȑOŁA
		{
			TWCR = (1<<TWEN)|							// TWI
				   (1<<TWIE)|(1<<TWINT)|				// TWI荞݋,TWI荞ݗv׸މ(0)
				   (1<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|		// MACKw
				   (0<<TWWC);							//
		}
		else										// ŏI޲ĂŁA
		{
			TWCR = (1<<TWEN)|							// TWI
				   (1<<TWIE)|(1<<TWINT)|				// TWI荞݋,TWI荞ݗv׸މ(0)
				   (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|		// MNACKw
				   (0<<TWWC);							//
		}
		break;
	case TWI_MRX_DATA_NACK:				// ް ޲ĎM,NACKԓ
		TWI_buf[TWI_bufPtr] = TWDR;				// MްlTWIMɏՕɊi[
		TWI_statusReg.lastTransOK = TRUE;		// ]׸ސݒ(1)
		TWCR = (1<<TWEN)|						// TWI
			   (0<<TWIE)|(1<<TWINT)|			// TWI荞݋֎~,TWI荞ݗv׸މ(0)
			   (0<<TWEA)|(0<<TWSTA)|(1<<TWSTO)|	// ~oJn
			   (0<<TWWC);							//
		break;
	case TWI_ARB_LOST:					// r(s)
		TWCR = (1<<TWEN)|						// TWI
			   (1<<TWIE)|(1<<TWINT)|			// TWI荞݋,TWI荞ݗv׸މ(0)
			   (0<<TWEA)|(1<<TWSTA)|(0<<TWSTO)|	// (đ)JnoJn
			   (0<<TWWC);							//
		break;
	case TWI_MTX_ADR_NACK:				// SLA+WM,NACKM
	case TWI_MRX_ADR_NACK:				// SLA+RM,NACKM
	case TWI_MTX_DATA_NACK:				// ް ޲đM,NACKM
	case TWI_BUS_ERROR:					// s@ȊJn܂͒~̂߂޽ُ
	default:
		TWI_state = TWSR;						// ُƂTWIԕݒ
		TWCR = (1<<TWEN)|						// TWI
			   (0<<TWIE)|(0<<TWINT)|			// TWI荞݋֎~
			   (0<<TWEA)|(0<<TWSTA)|(0<<TWSTO)|	// TWI޽J(NACK)
			   (0<<TWWC);						// (TWIؾ)
	}
}
